/*---------------------------------------------------------------------------------------
Arduino IDE 1.0.5
VVT-Projekt  VVT-Manager FW V01
Viessamnn VitoTronic mit Selbstbau-Optolink
OptoLink Simulation mit Arduino UNO
Serial Sender für Optolink Adapter = Serial TX (4800)

Achtung vor dem Hochladen des Programms - USB-Verbindung zum VVT-Manager Lösen
*/

#include <avr/pgmspace.h> 
#include <SPI.h>
#include <stdarg.h>
#include <stdio.h>

#define BOARD_LED    13
#define BYTE_01_LED   9
#define BYTE_F7_LED  10
#define BYTE_FF_LED  11

//------------------ProgramTimer----------------------------------------------------------

#define TimeInterval            1300    //für 1 Sekunde BasisZeit
#define Task1_Start             0
#define Task1_Dauer             5       // Hole Datum + UhrZeit
#define Task2_Dauer             5       // Hole VVT Daten
#define Task3_Dauer             5       // Schreibe VVT Daten auf SD Karte
//      Task4_Dauer      ............... bis Ende ProgDauer



//Array Message: MsgByte1, MsgByte2, AntwortLängeByte, AntwortByte1, AntwortByte2, AbfrageByte
//AbgfrageByte = 0 keine Abfrage, 0x10 = Abfrage
#define  VVT_MsgAnzahl    35

/*
byte VVT_Msg[VVT_MsgAnzahl][6]  =
{
  {0x00,0xF8,0x02,0,0,0x10},    //-0-Kennung
   //Ist
  {0x55,0x25,0x02,0,0,0x10},    //-1-Aussentemperatur Tiefpass
  {0x08,0x00,0x02,0,0,0x10},    //-2-Aussentemp Sensor 1
  {0x08,0x02,0x02,0,0,0x10},    //-3-Kesseltemp Sensor 3
  {0x08,0x04,0x02,0,0,0x10},    //-4-Speichertemp Sensor 5
  {0x08,0x06,0x02,0,0,0x10},    //-5-Speichertemp 2 Sensor 5B
  {0x08,0x08,0x02,0,0,0},    //-6-Abgastemp Sensor 15
  {0x08,0x0A,0x02,0,0,0},    //-7-Rücklauftemp
  {0x08,0x0C,0x02,0,0,0x10},    //-8-Vorlauftemp
  {0x39,0x00,0x02,0,0,0x10},    //-9-Vorlauftemp M2
  {0x39,0x02,0x02,0,0,0x10},    //-10-Vorlauftemp M3 ?
  {0xA3,0x09,0x02,0,0,0x10},    //-11-Kesseltemperatur (/100)
  {0x08,0x10,0x02,0,0,0x10},    //-12-Kesseltemp Tiefpass (/10)
  {0x08,0x12,0x02,0,0,0x10},    //-13-Speichertemp Tiefpass
  {0x08,0x14,0x02,0,0,0x10},    //-14-Speichertemp2 Tiefpass
  {0x63,0x00,0x02,0,0,0x10},    //-15-Warmwasser Soll
  
  //Soll
  {0x25,0x44,0x02,0,0,0x10},    //-16-Vorlaufsolltemp A1M1 (/10)
  {0x55,0x5A,0x02,0,0,0x10},    //-17-Kesselsolltemp (/10)
  {0x23,0x06,0x01,0,0,0x10},    //-18-RaumTemp Soll(3.37)
  
  //Betriebsart
  {0x23,0x01,0x01,0,0,0x10},    //-19-Betriebsart
  {0x23,0x02,0x01,0,0,0x10},    //-20-Sparbetrieb
  {0x23,0x03,0x02,0,0,0x10},    //-21-Partybetrieb
  
  //Heiz-Kennlinie
  {0x23,0x04,0x01,0,0,0x10},     //-22-Heizkennlinie Niveau
  {0x23,0x05,0x01,0,0,0x10},     //-23-Heizkennlinie Neigung (/10)
   
   //Status
  {0x55,0x27,0x02,0,0,0x10},     //-24-Aussentemp gedämpft
  {0x55,0x1E,0x01,0,0,0x10},     //-25-Brennerstatus 0 .. 2
  {0x55,0xE3,0x01,0,0,0x10},     //-26-aktuelle Leistung 0 .. 100% (/2)
  
  //Pumpen
  {0x08,0x45,0x01,0,0,0x10},     //-27-Speicherladepumpe 0 .. 1
  {0x08,0x46,0x01,0,0,0x10},     //-28-ZikulatPumpe KellerHeizung 0 .. 1
  {0x29,0x06,0x01,0,0,0x10},     //-29-Heizkreispumpe A1M1 0 .. 1
  {0x25,0x4C,0x01,0,0,0x10},     //-30-Mischerposition M1 0 .. 100% (/2)
  
  //Störung
  {0x08,0x47,0x01,0,0,0x10},     //-31-Sammel Störung 0 .. 1
  
  {0xFF,0x00,0x00,0,0,0}         //Ende Messages
  
};
*/

int       InputByteCnt  = 0;
int       intwert;
byte      OptoByte      = 0;

byte      InputArray[6] = {0,0,0,0,0,0};

boolean   Auswertung    = false;
boolean   OptoByteRead  = false;
int       OptoReadCnt   = 0; 

boolean   WertByte1     = false;
boolean   WertByte2     = false;
boolean   WertByte3     = false;

boolean  Byte01_ok      = false;
boolean  ByteF7_ok      = false;
boolean  ByteFF_ok      = false;

boolean  send1Byte      = false;
boolean  send2Byte      = false;

int      LEDInpCnt      = 0;

//------------------------------------------------------------------------------------------------



//------------------ProgramTimer-------------------------------------------------------------------

int Prog_Dauer   = 60;                   //Standard Prog. Zyklus Zeit in Sek.
int Task1_Ende;
int Task2_Start;                         // Hole VVT Daten
int Task2_Ende;
int Task3_Start;                         // Schreibe VVT Daten auf SD Karte
int Task3_Ende;
int Task4_Start;                         // JSON bis Ende ProgDauer
int Task4_Ende; 
unsigned long actualMillis = 0;
unsigned long zuvorMillis  = 0;
unsigned int  ControlTime  = 0;

void Calc_ProgTimer() { 
    Task1_Ende  = Task1_Start + Task1_Dauer;
    Task2_Start = Task1_Ende;                      // Hole VVT Daten
    Task2_Ende  = Task2_Start + Task2_Dauer;
    Task3_Start = Task2_Ende;                      // Schreibe VVT Daten auf SD Karte
    Task3_Ende  = Task3_Start + Task3_Dauer;
    Task4_Start = Task3_Ende;                      // JSON bis Ende ProgDauer
    Task4_Ende  = Prog_Dauer;
}


//-----------------------------------------------------------------------------------------------

void LED_Test() 
{
  for (int x=0; x<5; x++)
  {
  Serial.print(x);
  digitalWrite(BOARD_LED,HIGH);
  digitalWrite(BYTE_01_LED,HIGH);
  digitalWrite(BYTE_F7_LED,HIGH);
  digitalWrite(BYTE_FF_LED,HIGH);
  delay(50);
  digitalWrite(BOARD_LED,LOW);
  digitalWrite(BYTE_01_LED,LOW);
  digitalWrite(BYTE_F7_LED,LOW);
  digitalWrite(BYTE_FF_LED,LOW);
  delay(700);
  }
}


void Clear_LEDs()
{
  digitalWrite(BYTE_01_LED,LOW);
  digitalWrite(BYTE_F7_LED,LOW);
  digitalWrite(BYTE_FF_LED,LOW);
}


void clear_Array()
{
  for (byte x=0; x<6; x++) {InputArray[x] = 0; InputByteCnt  = 0;}
}


void Clear_Bytes()
{
  InputByteCnt  = 0;
  Byte01_ok     = false;
  ByteF7_ok     = false;
  ByteFF_ok     = false;
  WertByte1     = false;
  WertByte2     = false;
  WertByte3     = false;
  send2Byte     = false;
  send1Byte     = false;
}


//zeige freien RAM Speicherplatz - FreeMemory
int freeRam () {
  extern int __heap_start, *__brkval; 
  int v; 
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
}




//--------------------Prog-Ablauftimer------------------------------------------------------
//dieser kontrolliert den Ablauf der einzelnen Sequenzen :
//1.Zeitserver - 2.VVT-Daten lesen - 3.VVT-Datenaufzeichung - 4.Web-Requests

void ProgControl() {
     actualMillis = millis();
     if((actualMillis - zuvorMillis) > TimeInterval) {
        ControlTime++;
        LEDInpCnt--;
        OptoReadCnt--;
        
        if (OptoReadCnt <= 0)
        {
          digitalWrite(BOARD_LED,HIGH);
	  Serial.write(0x05);
          delay(20);
          digitalWrite(BOARD_LED,LOW);
          OptoReadCnt = 0;
        }
        
       if (ControlTime > Prog_Dauer) {ControlTime = 0;}
       if (LEDInpCnt < 0) {Clear_LEDs(); LEDInpCnt = 0;}
       
       zuvorMillis = actualMillis;
     }
}

//============================================================================================
//====================Haupt Funktionen========================================================

// setup - Intialisiert Hardware
// Achtung vor dem Hochladen des Programms - USB-Verbindung zum VVT-Manager Lösen
 
void setup() {

  Serial.begin(4800, SERIAL_8E2);
  //Serial.begin(4800);  //Debug-Monitor  und Test TX Output
  
  Serial.println("Init Outputs"); 
  pinMode(BOARD_LED,     OUTPUT);             //BoardLED
  pinMode(BYTE_01_LED,   OUTPUT);  
  pinMode(BYTE_F7_LED,   OUTPUT); 
  pinMode(BYTE_FF_LED,   OUTPUT);
  
  Serial.println("Programm Timer");  
  Calc_ProgTimer();
  Serial.print("LED Test ");  
  LED_Test();
  Serial.println(); 
  Serial.print("RAM frei: "); Serial.println(freeRam());
  Serial.println("Test Start........05,05,05...");
  InputByteCnt = 0;
}


//--------------Haupt Programm ---------------------------------------------------------
// Achtung vor dem Hochladen des Programms - USB-Verbindung zum VVT-Manager Lösen

void loop() 
{
  ProgControl();
  
  if (Serial.available() > 0)
  {
    OptoByte = Serial.read();
    InputArray[InputByteCnt] = OptoByte;
    InputByteCnt++;
    OptoReadCnt = 2; //erzeugt Pause beim senden von 0x05 falls Byte gelesen
    if (InputByteCnt >= 5) {Auswertung  = true;}
  }//Byte empfangen  


  if (Auswertung)
  {
    Auswertung  = false;
    Clear_Bytes;

    if (InputArray[0] == 0xFF) {ByteFF_ok = true; digitalWrite(BYTE_FF_LED,HIGH); LEDInpCnt = 2;} //Abfrage Adressen Ende erkannt
    if (InputArray[0] == 0x01) {Byte01_ok = true; digitalWrite(BYTE_01_LED,HIGH); LEDInpCnt = 2;}
    if (InputArray[1] == 0xF7) {ByteF7_ok = true; digitalWrite(BYTE_F7_LED,HIGH); LEDInpCnt = 2;}
    
    if (!ByteFF_ok)
    {
        //Kennung senden
        if ((InputArray[2] == 0x00)&&(InputArray[3] == 0xF8)&&(InputArray[4] == 0x02))
        { 
          Serial.write(0x20);
          Serial.write(0x98);
        }
    
        //keine Kennung
        if ((InputArray[2] >= 0x08)&&(InputArray[2] <= 0xA3)) {WertByte1 = true;}else{WertByte1 = false;}
        if ((InputArray[3] >= 0x00)&&(InputArray[3] <= 0xE3)) {WertByte2 = true;}else{WertByte2 = false;}
        if  (InputArray[4] == 0x01) {send1Byte = true; }else{send1Byte = false;}   
    
        if ((WertByte1)&&(WertByte2))
        {
           byte ro1 = random(10,200);
           byte ro2 = random(0,3);
           if (send1Byte) { Serial.write(ro1); }else{ Serial.write(ro1); Serial.write(ro2); }
        }

    }
    
    clear_Array();
   
  }//Auswertung

}//LoopEnde

